﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.Web.UI.WebControls.WebParts;
using Infragistics.Web.UI.GridControls;
using System.Collections;

namespace WebApplication1
{
    public enum FilterViews
    {
        ShowAll = 0,
        View2 = 1,
        View3 = 2,
        View4 = 3,
        View5 = 4,
        View6 = 5,
        View1 = 6,
    }
    public partial class _Default : System.Web.UI.Page
    {
        private static Random r = new Random();

        #region Page Events
        protected override void OnInit(EventArgs e)
        {
            WebDataGrid1.InitializeRow += new Infragistics.Web.UI.GridControls.InitializeRowEventHandler(WebDataGrid1_InitializeRow);
            WebDataGrid1.Load += new EventHandler(WebDataGrid1_Load);
            base.OnInit(e);
        }
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                PopulateFilterDropDown();
                PopulateWebDataGrid1();
            }
        }
        #endregion

        #region Grid Event Handlers
        private void WebDataGrid1_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
        {
            int Column22Index = WebDataGrid1.Columns["Column22"].Index;
            int Column2Index = WebDataGrid1.Columns["Column2"].Index;

            ((HyperLink)e.Row.Items[Column22Index].FindControl("lnkColumn22")).Text = "link";
            ((HyperLink)e.Row.Items[Column22Index].FindControl("lnkColumn22")).NavigateUrl = "http://www.google.com/?" + e.Row.Items[Column2Index].Text;
        }
        protected void WebDataGrid1_Load(object sender, EventArgs e)
        {

            PopulateDropDown("ddlColumn5", "Column5", "", "", false); //5


            PopulateDropDown("ddlColumn30", "Column30", "", "", false);
            PopulateDropDown("ddlColumn35", "Column35", "", "", false);
            PopulateDropDown("ddlColumn20", "Column20", "", "", false);
            PopulateDropDown("ddlColumn12", "Column12", "", "", false);
            PopulateDropDown("ddlColumn19", "Column19", "", "", false);
            PopulateDropDown("ddlColumn31", "Column31", "", "", false);
            PopulateDropDown("ddlColumn32", "Column32", "", "", false);
            PopulateDropDown("ddlColumn34", "Column34", "", "", false);
            PopulateDropDown("ddlColumn36", "Column36", "", "", false);
            PopulateDropDown("ddlColumn37", "Column37", "", "", false);
            PopulateDropDown("ddlColumn21", "Column21", "", "", false);
            PopulateDropDown("ddlColumn43", "Column43", "", "", false);



            FixColumn("Column4");
            FixColumn("Column5");
            FixColumn("Column7");
            FixColumn("Column8");
            FixColumn("Column9");


            int filter = -1;

            try
            {
                filter = int.Parse(ddlFilter.SelectedItem.Value);
            }
            catch
            {
                //trap and ignore
            }

            //reset hidden columns
            ShowAllColumns();

            switch (filter)
            {
                case (int)FilterViews.View2:
                    HideColumn("Column8");
                    HideColumn("Column9");
                    HideColumn("Column26");
                    HideColumn("Column27");
                    HideColumn("Column31");
                    HideColumn("Column31");
                    HideColumn("Column36");
                    HideColumn("Column35");
                    HideColumn("Column17");
                    HideColumn("Column18");
                    break;
                case (int)FilterViews.View3:
                    HideColumn("Column11");
                    HideColumn("Column13");
                    HideColumn("Column7");
                    HideColumn("Column21");
                    HideColumn("Column22");
                    HideColumn("Column24");
                    HideColumn("Column25");
                    HideColumn("Column26");
                    HideColumn("Column27");
                    HideColumn("Column39");
                    HideColumn("Column40");
                    HideColumn("Column41");
                    HideColumn("Column42");
                    HideColumn("Column43");
                    HideColumn("Column45");
                    HideColumn("Column44");
                    break;
                case (int)FilterViews.View4:
                    HideColumn("Column4");
                    HideColumn("Column5");
                    HideColumn("Column11");
                    HideColumn("Column13");
                    HideColumn("Column8");
                    HideColumn("Column9");
                    HideColumn("Column37");
                    HideColumn("Column38");
                    HideColumn("Column39");
                    HideColumn("Column40");
                    HideColumn("Column41");
                    HideColumn("Column42");
                    HideColumn("Column43");
                    break;
                case (int)FilterViews.View5:
                    HideColumn("Column11");
                    HideColumn("Column26");
                    HideColumn("Column27");
                    HideColumn("Column28");
                    HideColumn("Column31");
                    HideColumn("Column34");
                    HideColumn("Column33");
                    HideColumn("Column35");
                    HideColumn("Column36");
                    HideColumn("Column45");
                    HideColumn("Column44");
                    break;
                case (int)FilterViews.View6:
                    HideColumn("Column26");
                    HideColumn("Column27");
                    HideColumn("Column31");
                    HideColumn("Column35");
                    HideColumn("Column36");
                    HideColumn("Column39");
                    HideColumn("Column40");
                    HideColumn("Column41");
                    HideColumn("Column42");
                    HideColumn("Column43");
                    HideColumn("Column45");
                    HideColumn("Column44");
                    break;
                case (int)FilterViews.View1:
                    HideColumn("Column8");
                    HideColumn("Column9");
                    HideColumn("Column26");
                    HideColumn("Column27");
                    HideColumn("Column31");
                    HideColumn("Column31");
                    HideColumn("Column36");
                    HideColumn("Column35");
                    HideColumn("Column17");
                    HideColumn("Column18");
                    break;
                default:
                    break;
            }

        }
        #endregion

        #region Private Methods
        private void PopulateDropDown(string id, string CodeTableName, string unused1, string unused2, bool ColRequired)
        {
            IDictionary codeTable = new Dictionary<int, string>();
            if (!ColRequired) codeTable.Add(0, "  ");

            for (int i = 1; i < 10; i++)
            {
                codeTable.Add(i, CodeTableName + " " + i);
            }

            DropDownProvider ddl = (DropDownProvider)WebDataGrid1.EditorProviders.GetProviderById(id);
            ddl.EditorControl.DataSource = codeTable;
            ddl.EditorControl.TextField = "Value";
            ddl.EditorControl.ValueField = "Key";
            ddl.EditorControl.DataBind();
        }
        private void PopulateFilterDropDown()
        {
            Dictionary<string, string> ListItems = new Dictionary<string, string>();

            // First add the canned views for the MEL
            ListItems.Add(((int)FilterViews.ShowAll).ToString(), "Show All");
            ListItems.Add(((int)FilterViews.View1).ToString(), "View 1");
            ListItems.Add(((int)FilterViews.View2).ToString(), "View 2");
            ListItems.Add(((int)FilterViews.View3).ToString(), "View 3");
            ListItems.Add(((int)FilterViews.View4).ToString(), "View 4");
            ListItems.Add(((int)FilterViews.View5).ToString(), "View 5");
            ListItems.Add(((int)FilterViews.View6).ToString(), "View 6");

            ddlFilter.DataSource = ListItems;
            ddlFilter.DataValueField = "Key";
            ddlFilter.DataTextField = "Value";
            ddlFilter.DataBind();
        }
        private void PopulateWebDataGrid1()
        {

            Session["GridData"] = getTable();
            WebDataGrid1.DataSource = Session["GridData"];
            WebDataGrid1.DataBind();

            WebDataGrid1.Rows[0].Items[0].Column.Hidden = true;

        }

        private void FixColumn(string key)
        {
            ColumnFixing behavior = WebDataGrid1.Behaviors.GetBehavior<ColumnFixing>();
            if (behavior == null)
                behavior = WebDataGrid1.Behaviors.CreateBehavior<ColumnFixing>();

            behavior.FixedColumns.Add(new FixedColumnInfo(key, FixLocation.Left));

        }
        private void HideColumn(string key)
        {
            WebDataGrid1.Columns[key].Hidden = true;
        }
        private void ShowAllColumns()
        {
            
                    WebDataGrid1.Columns["Column31"].Hidden = false; //31
                    WebDataGrid1.Columns["Column7"].Hidden = false; //7
                    WebDataGrid1.Columns["Column21"].Hidden = false; //21
                    WebDataGrid1.Columns["Column22"].Hidden = false; //22
                    WebDataGrid1.Columns["Column24"].Hidden = false; //24
                    WebDataGrid1.Columns["Column25"].Hidden = false; //25
                    WebDataGrid1.Columns["Column4"].Hidden = false; //4
                    WebDataGrid1.Columns["Column5"].Hidden = false; //5
                    WebDataGrid1.Columns["Column11"].Hidden = false; //11
                    WebDataGrid1.Columns["Column13"].Hidden = false; //13
                    WebDataGrid1.Columns["Column37"].Hidden = false; //37
                    WebDataGrid1.Columns["Column38"].Hidden = false; //38
                    WebDataGrid1.Columns["Column39"].Hidden = false; //39
                    WebDataGrid1.Columns["Column41"].Hidden = false; //41
                    WebDataGrid1.Columns["Column42"].Hidden = false; //42
                    WebDataGrid1.Columns["Column43"].Hidden = false; //43
                    WebDataGrid1.Columns["Column12"].Hidden = false; //12
                    WebDataGrid1.Columns["Column28"].Hidden = false; //28
                    WebDataGrid1.Columns["Column31"].Hidden = false; //31
                    WebDataGrid1.Columns["Column34"].Hidden = false; //34
                    WebDataGrid1.Columns["Column33"].Hidden = false; //33
                    WebDataGrid1.Columns["Column35"].Hidden = false; //35
                    WebDataGrid1.Columns["Column36"].Hidden = false; //36
                    WebDataGrid1.Columns["Column45"].Hidden = false; //45
                    WebDataGrid1.Columns["Column44"].Hidden = false; //44
                    WebDataGrid1.Columns["Column26"].Hidden = false; //26
                    WebDataGrid1.Columns["Column27"].Hidden = false; //27
                    WebDataGrid1.Columns["Column40"].Hidden = false; //40
                    WebDataGrid1.Columns["Column8"].Hidden = false; //8
                    WebDataGrid1.Columns["Column9"].Hidden = false; //9
                    WebDataGrid1.Columns["Column17"].Hidden = false; //17
                    WebDataGrid1.Columns["Column18"].Hidden = false; //18
        }
        #endregion

        protected void ddlFilter_SelectedIndexChanged(object sender, EventArgs e)
        {
            PopulateWebDataGrid1();
            WebDataGrid1.DataBind();
        }

        #region Fake Grid Data
        private void addData(DataTable dt)
        {
            dt.Rows.Add(new object[] { 
                rand(),
                rand(),
                "text",
                rand(),
                rand(),
                "text",
                "text",
                rand(),
                (float)(rand() + rand()/10f),
                (float)(rand() + rand()/10f),
                rand(),
                rand(),
                rand(),
                (rand() > 5) ? 1 : 0, //yes/no field
                (rand() > 5) ? 1 : 0,
                rand(),
                (rand() > 5) ? 1 : 0,
                (rand() > 5) ? 1 : 0,
                rand(),
                rand(),
                rand(),
                "text",
                rand(),
                rand(),
                rand(),
                rand(),
                rand(),
                rand(),
                rand(),
                rand(),
                rand(),
                rand(),
                rand(),
                rand(),
                rand(),
                rand(),
                rand(),
                rand(),
                rand(),
                rand(),
                rand(),
                rand(),
                "text",
                rand(),
                rand(),
                rand(),
                (rand() > 5) ? 1 : 0,
                rand(),
                "text",
                DateTime.Now.ToString(),
                DateTime.Now.ToString()

            });
        }
        private int rand()
        {
            return r.Next(10);
        }

        private DataTable getTable(int size = 110)
        {
            DataTable dt = new DataTable("Equipment");
            int i = 0;
            while (i < 52)
            {
                i++;
                dt.Columns.Add("Column" + i);
            }

            while (size > 0)
            {
                addData(dt);
                size--;
            }

            return dt;
        }

        #endregion

    }
}
